;****************************************************************************************
;*                           DTMF-ANZEIGE VON DL3UKH                                    *
;*                           =======================                                    *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC16F88                                                   *
;* ALS OSZILLATOR WURDE DER INTERNE MIT 8,00MHZ GENOMMEN.(T=0.125SEC ALSO DIE TAKTZEIT)*
;*                                   EIN BEFEHL HAT MEIST 4 TAKTE SIND 0,5SEC          *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                           BEGINN: 13.05.19                                           *
;****************************************************************************************

        LIST    P=16F88       
        TITLE   "DTMF-ANZEIGE"

        ERRORLEVEL -302
        INCLUDE <P16F88.INC>

__CONFIG _CONFIG1, _CP_OFF & _CCPMX_RB0 & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BOREN_OFF & _MCLRE_OFF & _PWRTE_OFF & _WDTE_OFF & _FOSC_INTOSCIO
__CONFIG _CONFIG2, _IESO_OFF & _FCMEN_OFF



;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

;ZEITSCHLEIFE SPEICHERZELLE
HELP                    EQU     0X22       

;LCD SPEICHERZELLEN                    
HELP1                   EQU     0X23
MERKE                   EQU     0X24
BIT                     EQU     0X25

;DTMF AUSWERTUNG
DTMF                    EQU     0X26    ;AUSGELESENER  TON
ZAE                     EQU     0X27    ;TABELLEN ZHLER
COD                     EQU     0X28    ;WEGEN VERDREHTEM ANSCHLUSS VERGLEICHEN DEN CODE
ADR                     EQU     0X29                     
                     

;--------------------------- VARIABLEN -------------------------------------
BIT7                    EQU     7       ; BIT 7
BIT6                    EQU     6       ; BIT 6
BIT5                    EQU     5       ; BIT 5
BIT4                    EQU     4       ; BIT 4
BIT3                    EQU     3       ; BIT 3 
BIT2                    EQU     2       ; BIT 2
BIT1                    EQU     1       ; BIT 1 
BIT0                    EQU     0       ; BIT 0
;--------------------------------------------------------------------------

;------------------------- MACROS -----------------------------------------

BANK0           MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                BCF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK1           MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                BSF     STATUS,RP0
                BCF     STATUS,RP1
                ENDM

BANK2           MACRO                   ;MACRO TO SELECT DATA RAM BANK 2
                BCF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM

BANK3           MACRO                   ;MACRO TO SELECT DATA RAM BANK 3
                BSF     STATUS,RP0
                BSF     STATUS,RP1
                ENDM


;----------------------------------------------------------------------------
;-----------------------------------------------------------------------------

;SPEICHERANFANG BZW. BEGINN

                ORG 0X0000
                GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                ORG 0X0004
                RETFIE    ;GOTO    INTERRUPT

                ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN            CLRF    PORTA                           
                CLRF    PORTB

                BANK1
                MOVLW   B'01110010'             ;8MHZ INTERNER OSZILLATOR ALS RC-CLOCK
                MOVWF   OSCCON

                MOVLW   0X07                    ;COMPARATORS ALLE AUS VOM PORT A
                MOVWF   CMCON
;AD-INIT
                MOVLW   B'00000000'             ;ALLES IO-PORTS
                MOVWF   ANSEL
                
                MOVLW   B'01111111'             ;INIT INPUT/OUTPUT AM PORTA ALLES EINGANG / BEI 1 EINGANG  NUR RA7 AUSGANG
                MOVWF   TRISA
                MOVLW   B'00000000'             ;INIT I/O PORTB  ALLES AUSGANG 
                MOVWF   TRISB

;INIT TIMER 0 FUER 1MSEC
                MOVLW   B'10000111'             ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                MOVWF   OPTION_REG
                BANK0
  
;-----------------------------------------------------------------------------
;INIT-ENDE
                CLRF    PORTA
                CLRF    PORTB
                  
                MOVLW   D'100'
                CALL    ZS1MSEC
      
;INITIALISIERUNG DOT-MATRIX-LCD
            MOVLW   H'28'                   ;FUNCTION SET  4-BIT-LAENGE, 2/4ZEILIG, 5X7FONT
            CALL    BEFEHL

            MOVLW   H'0C'                   ;DISPLAY ON/OFF   DISPLAY ON, CURSOR OFF, BLINK OFF
            CALL    BEFEHL

            CALL    LOE
    
;----------- LCD-DOT-MATRIX-AUSGEBEN ------------------------
;-----------WARTE AUF / DTMF-TNE

SP11
            
;            MOVLW   H'80'                   ;ADRESSE 0 
;            CALL    BEFEHL
;            MOVLW   H'47'
;            CALL    DATEN

;            MOVLW   H'81'                   ;ADRESSE 1
;            CALL    BEFEHL
;            MOVLW   H'65'
;            CALL    DATEN

;            MOVLW   H'82'                   ;ADRESSE 2
;            CALL    BEFEHL
;            MOVLW   H'68'
;            CALL    DATEN

            MOVLW   H'83'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'57' ;W
            CALL    DATEN

            MOVLW   H'84'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'61' ;A
            CALL    DATEN

            MOVLW   H'85'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'72' ;R
            CALL    DATEN

            MOVLW   H'86'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'74' ;T
            CALL    DATEN

            MOVLW   H'87'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'65' ;E
            CALL    DATEN

            MOVLW   H'88'                   ;ADRESSE 8
            CALL    BEFEHL
            MOVLW   H'20'
            CALL    DATEN

            MOVLW   H'89'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'61' ;A
            CALL    DATEN

            MOVLW   H'8A'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'75' ;U
            CALL    DATEN

            MOVLW   H'8B'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'66' ;F
            CALL    DATEN

;            MOVLW   H'8C'                   ;ADRESSE C
;            CALL    BEFEHL
;            MOVLW   H'6C'
;            CALL    DATEN

;            MOVLW   H'8D'                   ;ADRESSE D
;            CALL    BEFEHL
;            MOVLW   H'6F'
;            CALL    DATEN

;            MOVLW   H'8E'                   ;ADRESSE E
;            CALL    BEFEHL
;            MOVLW   H'73'
;            CALL    DATEN

;            MOVLW   H'8F'                   ;ADRESSE F
;            CALL    BEFEHL
;            MOVLW   H'73'
;            CALL    DATEN

;--------------------------------------------------------------
;            MOVLW   H'C0'                   ;ADRESSE 0 
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN

;            MOVLW   H'C1'                   ;ADRESSE 1
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN

;            MOVLW   H'C2'                   ;ADRESSE 2
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN

            MOVLW   H'C3'                   ;ADRESSE 3
            CALL    BEFEHL
            MOVLW   H'44' ;D
            CALL    DATEN

            MOVLW   H'C4'                   ;ADRESSE 4
            CALL    BEFEHL
            MOVLW   H'54' ;T
            CALL    DATEN

            MOVLW   H'C5'                   ;ADRESSE 5
            CALL    BEFEHL
            MOVLW   H'4D' ;M
            CALL    DATEN

            MOVLW   H'C6'                   ;ADRESSE 6
            CALL    BEFEHL
            MOVLW   H'46' ;F
            CALL    DATEN

            MOVLW   H'C7'                   ;ADRESSE 7
            CALL    BEFEHL
            MOVLW   H'2D' ;-
            CALL    DATEN

            MOVLW   H'C8'                   ;ADRESSE 8
            CALL    BEFEHL
            MOVLW   H'54' ;T
            CALL    DATEN

            MOVLW   H'C9'                   ;ADRESSE 9
            CALL    BEFEHL
            MOVLW   H'6F' ;O
            CALL    DATEN

            MOVLW   H'CA'                   ;ADRESSE A
            CALL    BEFEHL
            MOVLW   H'65' ;E
            CALL    DATEN

            MOVLW   H'CB'                   ;ADRESSE B
            CALL    BEFEHL
            MOVLW   H'6E' ;N
            CALL    DATEN

            MOVLW   H'CC'                   ;ADRESSE C
            CALL    BEFEHL
            MOVLW   H'65' ;E
            CALL    DATEN

;            MOVLW   H'CD'                   ;ADRESSE D
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN

;            MOVLW   H'CE'                   ;ADRESSE E
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN

;            MOVLW   H'CF'                   ;ADRESSE F
;            CALL    BEFEHL
;            MOVLW   H'2D'
;            CALL    DATEN                

            MOVLW   D'250'
            CALL    ZS1MSEC
       
            MOVLW   0X80
            MOVWF   ADR
            
            
;WARTEN BIS STD EIN IST(ALSO HIGH) BIS KEINE GLEICHEN DATEN MEHR ANLIEGEN
SP2             BTFSC   PORTA, BIT4 
                GOTO    SP2A
                BCF     PORTA, BIT7
                
;RESET TASTER AUSWERTEN                
                BTFSC   PORTA, BIT6
                GOTO    SP2
                CALL    LOE
                GOTO    SP11
                

SP2A            MOVF    PORTA, W
                ANDLW   0X0F
                MOVWF   DTMF
                
;DTMF-TON-ANZEIGEN
                CLRF    ZAE
DT1             CALL    CODE_VERG
                
                MOVWF   COD
                
                SUBLW   0XFF
                BTFSC   STATUS, Z
                GOTO    SP3
                
                MOVF    COD, W
                SUBWF   DTMF, W        

                BTFSC   STATUS, Z       ;ZERO-ABFRAGE BEI HIGH(1) IST ES GLEICH / BEI LOW (0) UNGLEICH
                GOTO    GLEICH
                INCF    ZAE, F
                GOTO    DT1

GLEICH          MOVF    ADR, W
                SUBLW   0X80
                BTFSC   STATUS, Z
                CALL    LOE
                
                MOVF    ADR, W
                CALL    BEFEHL
                
                CALL    TON_ANZ
                CALL    DATEN

;ADRESSE ERHHEN
                INCF    ADR, F
                MOVF    ADR, W
                
                SUBLW   0XD0
                BTFSS   STATUS, Z
                GOTO    SP4
                GOTO    SP5
                 
SP4             MOVF    ADR, W
                SUBLW   0X90
                BTFSS   STATUS, Z
                GOTO    SP3
                
                MOVLW   0XC0
                MOVWF   ADR
                
;NEUER DTMF-TON                
SP3             BTFSS   PORTA, BIT4
                GOTO    SP2
                BSF     PORTA, BIT7
                GOTO    SP3

;ENDE 32 TNE WARTE AUF RESET           
SP5             BTFSC   PORTA, BIT6
                GOTO    SP51
                CALL    LOE
                GOTO    SP11
                
SP51            BTFSS   PORTA, BIT4
                GOTO    SP52
                BSF     PORTA, BIT7
                GOTO    SP5
                
SP52            BCF     PORTA, BIT7
                GOTO    SP5
 ;-----------------------------------------------------------------               
                
                 
                
;*****************************************************************************
;*                              LOESCHEN DOT-LCD-MODUL                       *
;*****************************************************************************
 LOE        MOVLW   H'01'                   ;CLEAR DISPLAY
            CALL    BEFEHL
            
            MOVLW   D'3'
            CALL    ZS1MSEC
            RETURN
            
;*****************************************************************************
;*                              DATEN AUSGEBEN AUF DOT-LCD-MODUL             *
;*****************************************************************************
DATEN       BSF     PORTB, BIT3               ;ALS DATEN

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTB, BIT2             ;ENABLE

;ZEITSCHLEIFE 4SEC
            MOVLW   D'2'                    ;UNGEFAEHR 4SEC ZEITSCHLEIFE
            MOVWF   HELP1
D1          NOP                             ;T=4
            DECFSZ  HELP1, F                ;T=4
            GOTO    D1                      ;T=8    GES.:16TAKTE * 0,125SEC= 2SEC    *2 DURCHLAEUFE= 4SEC
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, BIT2

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB


            BSF     PORTB, BIT2             ;ENABLE

;ZEITSCHLEIFE 4SEC
            MOVLW   D'2'                    
            MOVWF   HELP1
DDD1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    DDD1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, BIT2

;ZEITSCHLEIFE 40SEC
            MOVLW   D'20'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP1
DDDD1       NOP
            DECFSZ  HELP1, F                ;WIE OBEN  
            GOTO    DDDD1
;ENDE ZEITSCHLEIFE



            RETURN

;*****************************************************************************
;*                              BEFEHL AUSGEBEN AUF DOT-LCD-MODUL            *
;*                              04.05.10                                     *
;*****************************************************************************
BEFEHL      BCF     PORTB, BIT3                ;ALS BEFEHL

            MOVWF   BIT

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTB, BIT2

;ZEITSCHLEIFE 4SEC
            MOVLW   D'2'
            MOVWF   HELP1
B1          NOP                             
            DECFSZ  HELP1, F               
            GOTO    B1                     
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, BIT2

;---------------------------------

;LOW 4BIT AUSGEBEN
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F
            RLF     BIT, F

            MOVF    PORTB, W
            ANDLW   0X0F
            MOVWF   MERKE

            MOVF    BIT, W
            ANDLW   0XF0
            ADDWF   MERKE, W
            MOVWF   PORTB

            BSF     PORTB, BIT2

;ZEITSCHLEIFE 4SEC
            MOVLW   D'2'                    
            MOVWF   HELP1
BBB1        NOP                             
            DECFSZ  HELP1, F                
            GOTO    BBB1                    
;ENDE ZEITSCHLEIFE
 
            BCF     PORTB, BIT2

;ZEITSCHLEIFE 40SEC
            MOVLW   D'20'                   ;UNGEFAEHR 40SEC ZEITSCHLEIFE
            MOVWF   HELP1
BBBB1       NOP
            DECFSZ  HELP1, F                ;WIE OBEN  
            GOTO    BBBB1
;ENDE ZEITSCHLEIFE
 
            RETURN


;*****************************************************************************
;*                              1MSEC ZEITSCHLEIFE                           *
;*****************************************************************************
ZS1MSEC                 MOVWF   HELP

ZS11                    MOVLW   D'248'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD GELADEN
                        BCF     INTCON, TMR0IF          ;OVERFLOW = 0
                
ZS12                    BTFSS   INTCON, TMR0IF          ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    ZS12                    ;ES ERFOLGT EIN SPRUNG ZU "DECFSC HELP, F"..... VORHER ANDERES ABARBEITEN

                        DECFSZ  HELP, F                 ;ES WIRD DER WERT IN "HELP" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    ZS11                    ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS

                        RETURN

;ZEITBERECHNUNG FUER 1MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.125S=128,0SEC /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;1MS : 128S= 7,8  GENOMMEN 8                                      /T = 1 : F  (F)-OSZILLATORFREQUENZ HIER 8MHZ
;ALSO 
;128S*D'8'=1,024MSEC
;TMR0 ALSO D'256'-D'8'=D'248' ENTSPRICHT CA. 1MSEC
;248 DEZIMAL OBEN EINTRAGEN

                        
                        ORG 0X0300 
;*****************************************************************************
;*                              COD TABELLE                                  *
;*****************************************************************************
CODE_VERG
    MOVLW   H'03'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0300 
    MOVWF   PCLATH

    MOVF    ZAE, W      ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
    RETLW D'8'  ;"1"  
    RETLW D'4'  ;"2"
    RETLW D'12' ;"3"
    RETLW D'2'  ;"4"
    RETLW D'10' ;"5"
    RETLW D'6'  ;"6"
    RETLW D'14' ;"7"
    RETLW D'1'  ;"8"
    RETLW D'9'  ;"9"
    RETLW D'5'  ;"0"
    RETLW D'13' ;0X2A ;*
    RETLW D'3'  ;0X23 ;#
    RETLW D'11' ;"A"
    RETLW D'7'  ;"B"
    RETLW D'15' ;"C"
    RETLW D'0'  ;"D"


    RETLW 0XFF      ;ENDEKENNZEICHEN MUSS DRIN SEIN /// ICH BENUTZE ES IMMER IN EINER TABELLE
                        
                        
                        
                        
                        
                        
                           ORG 0X0400                     
;*****************************************************************************
;*                              ANZEIGE TABELLE                              *
;*****************************************************************************
TON_ANZ
    MOVLW   H'04'       ;ADRESSE SPEICHERN NEUES PCLATH///DA OBEN ORG 0X0400 
    MOVWF   PCLATH

    MOVF    ZAE, W      ; SPRUNGDISTANZ
    ADDWF   PCL,F       ; AUF STELLE DES ZU LESENDEN BYTES BRINGEN  

    
;----------------------------------------------------------------------------------------------
;----------------------------------------------------------------------------------------------
        
    RETLW "1"  
    RETLW "2"
    RETLW "3"
    RETLW "4"
    RETLW "5"
    RETLW "6"
    RETLW "7"
    RETLW "8"
    RETLW "9"
    RETLW "0"
    RETLW 0X2A ;*
    RETLW 0X23 ;#
    RETLW "A"
    RETLW "B"
    RETLW "C"
    RETLW "D"

    RETLW 0XFF      ;ENDEKENNZEICHEN MUSS DRIN SEIN /// ICH BENUTZE ES IMMER IN EINER TABELLE
                        
                        
                        
                        
                                     
                        
                        
                        
 
                        
                        
                        
                        
                        
                        

            END





